"Written by Hasan Besriovic - Spring 2020"
"A script to extract frequency data for a hydrofoil"

import Simple_Functions as SF
import matplotlib.pyplot as plt

"Gets data that is wanted"
Datagroups = ["NewRun"]#,"Sweep2-100-1000Hz4Hzincrements@0,3sEach_0",
Tdms_files = ["STRAIN_GAUGE/VG_Foil/NaturalFrequency/NaturalFrequencyPreMeasurements.tdms"]#,
              #"STRAIN_GAUGE/Ref_Foil/NaturalFrequency/ReferenceFoilFreqSweepClosedWater.tdms"]
Titles = ["VG foil","Reference foil"]
Max_plot_freq = 1200
Min_plot_freq = 500

"Welch with a Hanning window with 50% overlap"
data = SF.Welch_func(Tdms_files, Datagroups, None, 'N', Min_plot_freq, Max_plot_freq, 1)
Pspektrum = data[0]
f = data[1]
Pspektrum_max = data[2]
f_max = data[3]
Pspektrum_secondMax = data[4]
f_secondMax = data[5]

"Plotting"
Numbering = ["a)","b)","c)","d)","e)","f)","g)","h)","i)","k)","l)","m)","n)","o)","p)"]
k = 0
if len(Tdms_files)/len(Datagroups) == 1:
    fig, axs = plt.subplots(len(Datagroups) / len(Tdms_files),len(Tdms_files), figsize=(12, 8))
else:
    fig, axs = plt.subplots(len(Tdms_files), len(Datagroups) / len(Tdms_files), figsize=(15, 10))

for i in range(len(Tdms_files)):
    for j in range(len(Datagroups) / len(Tdms_files)):
        "For one sweep (1-Figure)"
        if len(Datagroups) == 1:
            plt.plot(f[j+k],Pspektrum[j+k], color="k")
            plt.ticklabel_format(axis='y', style='sci',scilimits=(-2, 2))
            #plt.title(Datagroups[j+k])
            plt.annotate("("+str(round(f_max[j+k],2))+"Hz)",xy=(f_max[j+k]*1.02,Pspektrum_max[j+k]*0.9),
                         fontsize = 12)
            plt.annotate("("+str(round(f_secondMax[j+k],2))+")",xy=(f_secondMax[j+k],
                                                                    Pspektrum_secondMax[j+k]*1.20),fontsize = 12)
            "For one sweep-file, with several sweeps (1-Row)"
        elif len(Tdms_files) < 2:
            axs[j].plot(f[j+k],Pspektrum[j+k], color="k")
            axs[j].ticklabel_format(axis='y', style='sci',scilimits=(-2, 2))
            axs[j].set_title(Datagroups[j+k])
            axs[j].annotate("("+str(round(f_max[j+k],2))+")",xy=(f_max[j+k]*1.02,Pspektrum_max[j+k]*0.9),
                            fontsize = 12)
            axs[j].annotate("("+str(round(f_secondMax[j+k],2))+")",xy=(f_secondMax[j+k],
                                                                       Pspektrum_secondMax[j+k]*1.20),fontsize = 12)
            "For several sweep-files, with several sweeps (len(Tdms_file)-Rows & len(Datagroups)-Columns)"
        elif len(Tdms_files)/len(Datagroups) == 1:
            axs[i].plot(f[j + k], Pspektrum[j + k], color="k")
            axs[i].ticklabel_format(axis='y', style='sci',scilimits=(-2, 2))
            axs[i].set_title(Numbering[j+k],fontsize = 18)
            axs[i].annotate("("+str(round(f_max[j+k],2))+"Hz)",xy=(f_max[j+k]*1.02,Pspektrum_max[j+k]*0.9),
                            fontsize = 14)
            axs[i].annotate("("+str(round(f_secondMax[j+k],2))+"Hz)",xy=(f_secondMax[j+k]*0.90,
                                                                         Pspektrum_secondMax[j+k]*1.50),fontsize = 14)
            axs[i].tick_params(labelsize=14)
        else:
            axs[i,j].plot(f[j + k], Pspektrum[j + k], color="k")
            axs[i,j].ticklabel_format(axis='y', style='sci',scilimits=(-2, 2))
            axs[i,j].set_title(Datagroups[j+k])
            axs[i,j].annotate("("+str(round(f_max[j+k],2))+")",xy=(f_max[j+k]*1.02,Pspektrum_max[j+k]*0.9),
                              fontsize = 12)
            axs[i,j].annotate("("+str(round(f_secondMax[j+k],2))+")",xy=(f_secondMax[j+k]*0.98,
                                                                         Pspektrum_secondMax[j+k]*1.50),fontsize = 12)

    k = k + len(Datagroups) / len(Tdms_files)

"""""
Labels to compare tdms files internally 
if len(Datagroups) > 1:

    Label = ["Pre Measurements", "Post Measurements", "Post Retake Measurements"]
    if len(Tdms_files)>2:
        for i in range(len(Tdms_files)):
                axs[i,0].set(ylabel = Label[i])
    elif len(Tdms_files)>1:
        for i in range(len(Tdms_files)):
                axs[i].set(ylabel = Label[i])
"""""
"To add a common x and y label"
fig.add_subplot(111, frameon=False)
plt.tick_params(labelcolor='none', top=False, bottom=False, left=False, right=False)
plt.xlabel("Frequency [Hz]",fontsize=16)
plt.ylabel("Amplitude [RMS]",fontsize=16)

plt.tight_layout()
plt.savefig("PICS/GraphsToUse/NaturalFrequencyVGs.pdf")
plt.show()