"Created by Hasan Besirovic"
"Script which get Peak ratio histogram data and plots this. Also finds values under a specific value"

import matplotlib.pyplot as plt
import Simple_Functions as SF


File = "PIV/Peak_ratio/Peak_ratio_10_1ms/B00001.dat"
"Defining the range for plotting"
Max_peak_ratio = 20
Min_peak_ratio = 0.01

"Getting the data"
xy = SF.xy_plotting(File)
Number_all = xy[2]
Peak_ratio = xy[0]

"Finding the plotting range positions"
Max_range = SF.maxmin_freq(Peak_ratio,Max_peak_ratio)
Min_range = SF.maxmin_freq(Peak_ratio,Min_peak_ratio)

"Limiting the functions for plotting"
Number = Number_all[Min_range:Max_range]
Peak_ratio = Peak_ratio[Min_range:Max_range]

"Finding the sum of vectors with peak ratio below either one or two values"
summing = 0
summing_3 = 0
for i in range(len(Number)):
    if Peak_ratio[i] <= 2:
        summing = summing+Number[i]
    if Peak_ratio[i] <= 3:
        summing_3 = summing_3+Number[i]

"Plotting"
plt.figure(figsize=(6,4.5))
plt.plot(Peak_ratio,Number,color='darkgray')
plt.ylim(-5,max(Number)+32)
plt.xlabel("Peak ratio", fontsize = 12)
plt.ylabel('Number of vectors', fontsize = 12)

plt.text(0,max(Number)+10,"Vectors with peak ratio below 3: "+str(summing_3)+
         "("+str(round(summing_3/sum(Number_all)*100,2))+"%)",weight = 'bold',
         bbox=dict(facecolor='none', edgecolor='red'))

plt.tight_layout()
plt.savefig('PICS\GraphsToUse\PeakRatio_Histogram_10_1ms.pdf')
plt.show()
