"Created by Hasan Besirovic"
"Script which calculates the the uncertainty from for each vector from a histogram plot"

import matplotlib.pyplot as plt
import Simple_Functions as SF
import numpy as np

"Choosing the file"
File_Velo = "13_1"
AVG_or_NO = "AVG_" #"AVG_" or "_"
SWP_or_NO = "" #"_SWP or ""
File = "PIV/Uncertainty/V_Uncertainty" + AVG_or_NO +File_Velo + "ms"+SWP_or_NO+"/B00001.dat"
File_AvgVelo = "PIV/AvgV/"+File_Velo+"ms_AvgV_40mm/B00001.dat"

"Defining the range for plotting"
Min_peak_ratio = 0.01

"Getting the data"
#Uncertainty data
xy = SF.xy_plotting(File)
Number_all = xy[2]
Uncertainty = xy[0]
#AVG velocity data for reference velocity
U_ref = np.mean(SF.xy_plotting(File_AvgVelo)[1])

"Making the velocity uncertainty dimensionless"
Uncertainty_dimless = []
for k in Uncertainty:
    Uncertainty_dimless.append(k/U_ref)

"Finding the plotting range positions"
Min_range = SF.maxmin_freq(Uncertainty,Min_peak_ratio)
Min_range_dimless = SF.maxmin_freq(Uncertainty_dimless,Min_peak_ratio)

"Limiting the functions for plotting"
Number = Number_all[Min_range:]
Uncertainty = Uncertainty[Min_range:]
Uncertainty_dimless = Uncertainty_dimless[Min_range:]

"Finding the number of vectors with uncertainty above a certain value"
summing = 0
Uncertainty_limit = 0.035
for i in range(len(Number)):
    if Uncertainty_dimless[i] >= Uncertainty_limit:
        summing = summing+Number[i]

"Plotting"
plt.figure(figsize=(6,4.5))
plt.plot(Uncertainty_dimless,Number,color='darkgray')
plt.ylim(-5,max(Number)+15)
plt.xlabel("Uncertainty [U/$U_{ref}$]",fontsize = 12)
plt.ylabel('Number of vectors',fontsize = 12)

plt.text(0,max(Number)+5,"Vectors with uncertainty above "+str(Uncertainty_limit) + ": "+str(summing)+
         " ("+str(round(summing/sum(Number_all)*100,2))+"%)",weight = 'bold',
         bbox=dict(facecolor='none', edgecolor='red'))

plt.tight_layout()
plt.savefig('PICS\GraphsToUse\Uncertainty_V_Histogram_13_1_AVG.pdf')
plt.show()
