"Created by Hasan Besirovic"
"Script which plots and calculates a frequency comparison plot"

import Simple_Functions as SF
import matplotlib.pyplot as plt
import numpy as np
"limiting the data"
max_freq = 1000
min_freq = 150
"Importing the data"
Files = ["STRAIN_GAUGE/VG_Foil/SymPlaneMeasurements/RampDown.tdms"]

#Strain Gauge data
SamplesPerWindow = 1000
data = SF.Welch_and_Max_of_data(Files,"Strain", max_freq,min_freq,SamplesPerWindow)
Error_SecPeak = np.transpose(data[5])
Error_FirstPeak = np.transpose(data[6])

#PIV DATA
Velocity_files_PIV = ["8","9_1","9_6","10_1","10_6","11_1","13_1"]

data_PIV = SF.Welch_func_PIV(Velocity_files_PIV,None,'N',min_freq,max_freq)
P_max = data_PIV[2]
f_max = data_PIV[3]
Velo = data_PIV[5]
"To plot the errorbars of PIV data found from FWHM (Full Width Half Maximum)"
SamplesPerWindow = 100
data_PIV_2 = SF.Welch_func_PIV(Velocity_files_PIV,None,SamplesPerWindow,min_freq,max_freq)
Error_PIV = np.transpose(data_PIV_2[6])

"Experimental Strouhal number"
St = 0.274

"To find the R value of the PIV points to the strouhal graph"
Strouhal_Linefit = [i*St*1000/4.8 for i in Velo]
Horisont = [sum(f_max)/len(f_max)]*len(Velo)

Differences_Strouhal = [Strouhal_Linefit[i]-f_max[i] for i in range(len(f_max))]
Linesum_Strouhal = 0
for i in Differences_Strouhal:
    Linesum_Strouhal = Linesum_Strouhal+i*i

Differences_Horisont = [Horisont[i]-f_max[i] for i in range(len(f_max))]
Linesum_Horisont = 0
for i in Differences_Horisont:
    Linesum_Horisont = Linesum_Horisont + i*i

R = (Linesum_Horisont-Linesum_Strouhal)/Linesum_Horisont
print R

"Plotting"
fig, ax1 = plt.subplots()

ax1.errorbar(data[1], data[2],yerr=Error_SecPeak,capsize=3,
             label = "Straingauge Second peak",marker='o',markerfacecolor ='None',color='k',ls='none')
ax1.errorbar(data[4],data[3],yerr=Error_FirstPeak,capsize=3,marker="P",color='k',
             label = "Straingauge First peak",ls='none')
ax1.errorbar(Velo,f_max,yerr=Error_PIV,marker="d",color='k', label = "PIV",capsize=3,markerfacecolor = 'None')
ax1.plot(data[1],[i*St*1000/4.8 for i in data[1]],'--',color = "r",label = "Strouhal (St = 0.274)")
ax1.set_xlabel("$U_{ref}$ [m/s]")
ax1.set_ylabel("Frequency [Hz]")
ax1.set_ylim(200,900)
ax1.set_xlim(5.9,14.1)
plt.grid()

"Dividing the axis such that the right axis is amplitude"
ax2 = ax1.twinx()
ax2.plot(data[1], data[0]/max(data[0]),"s-",color="darkgray", label = "Strain amplitude")
ax2.set_xlabel("$U_{ref}$ [m/s]")
ax2.set_ylabel("A/$A_{max} [RMS]$",color="darkgray")
ax2.tick_params(axis='y', labelcolor = "darkgray")
ax2.set_ylim(0,4)

fig.tight_layout()
fig.legend(bbox_to_anchor=(0.5,0.95))
plt.savefig("PICS/GraphsToUse/Vibration_Frequencies.pdf")
plt.show()