"Written by Hasan Besriovic - Spring 2020"
"Script which extracts data from PIV data plots and plots it"

import matplotlib.pyplot as plt
import Simple_Functions as SF
import os

"Specify which data to extract"
Str_1 = "PIV/AvgV/"
Str_2 = ["ms_AvgV_40mm/B00001.dat"]#,"ms_AvgV_60mm/B00001.dat"]
Str_3 = ["8","9_1","9_6","10_1","10_6","11_1","13_1"]
Standardeviation = ["ms_AvgV_40mm/B00002.dat"]#,"ms_AvgV_60mm/B00002.dat"]
Uncertainty_loc = "PIV/Uncertainty/xy-plot/SYM/"
Uncertainty_Str =  ["ms_Uncertainty_V_40mm/B00001.dat"]

Files = []
ErrorFiles = []
for i in range(len(Str_2)):
    for Str in Str_3:
        Files.append(Str_1+Str+Str_2[i])
        ErrorFiles.append((Uncertainty_loc+Str+Uncertainty_Str[i]))

"plotting"
fig,ax = plt.subplots(1,len(Str_2), figsize = (10,6))

"For the legend"
k=0
Ref_Velo = [8,9.1,9.6,10.1,10.6,11.1,13.1]
for i in range(len(Ref_Velo)):
    Ref_Velo[i] = "$U_{ref}$ = "+str(Ref_Velo[i])+"m/s"

D = 4.8
for i in range(len(Str_2)):
    for j in range(len(Str_3)):
        xy = SF.xy_plotting(Files[j+k])
        y = [Value/D for Value in xy[0]]
        x = [(Value-(sum(xy[1])/len(xy[1])))/(sum(xy[1])/len(xy[1]))for Value in xy[1]]

        "Calculating the error and add for errorbars"
        if os.path.isfile(ErrorFiles[j+k]):
            Velo_error = [Value/(2*D*sum(xy[1])/len(xy[1]))
                          for Value in SF.xy_plotting(ErrorFiles[j+k])[1]]

        PosMinVelo = y[x.index(min(x))]
        yplot = []
        xplot = []
        Velo_errorplot = []
        for y_val in y:
            Range  = 4
            if y_val >= PosMinVelo-Range and PosMinVelo+Range >= y_val:
                yplot.append(y_val)
                xplot.append(x[y.index(y_val)])
                if os.path.isfile(ErrorFiles[j+k]):
                    if len(Velo_error)>y.index((y_val)):
                        Velo_errorplot.append(Velo_error[y.index(y_val)])
                    else:
                        Velo_errorplot.append(Velo_error[len(Velo_error)-1])

        "Choose which data has errorbars"
        if len(Str_2)<2:
            if Str_3[j+k] == "9_1" or Str_3[j+k]=='13_1':
                plt.errorbar(xplot,yplot,xerr=Velo_errorplot,capsize=3,label = Ref_Velo[j],marker='o',
                             markerfacecolor ='None')
            else:
                plt.plot(xplot,yplot,label = Ref_Velo[j])

            plt.xlim(-0.20, 0.05)
            plt.ylim(13.5,17)
            plt.grid()
            "For several plots in one figure"
        else:
            if Str_3[j+k] == "9_1" or Str_3[j+k]=="13_1":
                ax[i].errorbar(xplot,yplot,xerr=Velo_errorplot,capsize=3,label = Ref_Velo[j],marker ="x")
            else:
                ax[i].plot(xplot,yplot,label = "$U_{ref}$= "+str(Ref_Velo[j+k])+"m/s")

            ax[i].set_xlim(-0.20, 0.05)
            ax[i].set_ylim(13.5,17)
            ax[i].grid()
            ax[i].set_title(Str_2[i].split('ms_AvgV_')[1].split('/')[0])

    k = k + len(Str_3)

"To organise the legend such that it is alphabethical"
handles, labels = ax.get_legend_handles_labels()
handles_sort = []
for i in range(len(labels)):
    handles_sort.append(handles[labels.index(Ref_Velo[i])])

plt.legend(handles_sort,Ref_Velo,fontsize = 14,loc='center right')

"To add common y and x labels"
fig.add_subplot(111, frameon=False)
plt.tick_params(labelcolor='none', top=False, bottom=False, left=False, right=False)
plt.ylabel("y/D", fontsize=20)
plt.xlabel(r"$\dfrac{U-U_{ref}}{U_{ref}}$", fontsize=20)

plt.tight_layout()
plt.savefig("PICS/GraphsToUse/AverageVelocity_40mm.pdf")
plt.show()

