"Written by Hasan Besriovic - Spring 2020"
"Script which extracts data from PIV data plots and plots it"

import matplotlib.pyplot as plt
import Simple_Functions as SF

"Specify which data to extract"
Str_1 = "PIV/Vorticity/"
Str_2 = ["ms_Vorticity_SWP_50mm/B00001.dat"]#,"ms_Vorticity_SWP_70mm/B00001.dat"]
Str_3 = ["9_1","10_1","13_1"]
Standardeviation = ["ms_Vorticity_SWP_50mm/B00002.dat"]#,"ms_AvgV_60mm/B00002.dat"]
Files = []
ErrorFiles = []
for i in range(len(Str_2)):
    for Str in Str_3:
        Files.append(Str_1+Str+Str_2[i])
        ErrorFiles.append((Str_1+Str+Standardeviation[i]))

"Plotting"
fig,ax = plt.subplots(1,len(Str_2), figsize = (9,7.5))

"For the legend"
k=0
Ref_Velo_1 = [9.1,10.1,13.1]
Ref_Velo = [9.1,10.1,13.1]
for i in range(len(Ref_Velo)):
    Ref_Velo[i] = "$U_{ref}$ = "+str(Ref_Velo[i])+"m/s"

D = 4.8
for i in range(len(Str_2)):
    for j in range(len(Str_3)):
        xy = SF.xy_plotting(Files[j+k])
        y = [Value/D for Value in xy[0]]
        x = [Value*D/(1000*Ref_Velo_1[j]) for Value in xy[1]]

        "Calculating the error and add for errorbars"
        Vorticity_error = [Value*0.0000003 for Value in SF.xy_plotting(ErrorFiles[j + k])[1]]

        "Choose which data has errorbars"
        if len(Str_2)<2:
            if Str_3[j] == "10_1_":
                plt.errorbar(x,y,xerr=Vorticity_error,capsize=2,label = Ref_Velo[j])
            else:
                plt.plot(x,y,label=Ref_Velo[j])
            plt.xlim(-0.20, 0.20)
            plt.grid()
            "For several plots in the same figure"
        else:
            if Str_3[j] == "10_1_":
                ax[i].errorbar(x,y,xerr=Vorticity_error,capsize=2,label = Ref_Velo[j])
            else:
                ax[i].plot(x,y,label=Ref_Velo[j])
            ax[i].set_xlim(-0.16, 0.16)
            ax[i].grid()
            ax[i].set_title(Str_2[i].split('ms_Vorticity_SWP_')[1].split('/')[0] + "Downstream")

    k = k + len(Str_3)

"To organise the legend such that it is alphabethical"
handles, labels = ax.get_legend_handles_labels()
handles_sort = []
for i in range(len(labels)):
    handles_sort.append(handles[labels.index(Ref_Velo[i])])

plt.legend(handles_sort,Ref_Velo,fontsize = 14,loc='upper left')

"To add common y and x labels"
fig.add_subplot(111, frameon=False)
plt.tick_params(labelcolor='none', top=False, bottom=False, left=False, right=False)
plt.ylabel("z/D",fontsize=20)
plt.xlabel(r'$\dfrac{-Vorticity \cdot D}{U_{ref}}$', fontsize=20)

fig.tight_layout()
plt.savefig("PICS/GraphsToUse/VorticitySWP_50mm.pdf")
plt.show()


