"Written by Hasan Besriovic - Spring 2020"
"Script which extracts data from PIV data plots and plots it"

import matplotlib.pyplot as plt
import Simple_Functions as SF

"Specify which data to extract"
Str_1 = "PIV/Vorticity/"
Str_2 = ["ms_Vorticity_60mm/B00001.dat"]#,"ms_Vorticity_40mm/B00001.dat"]
Str_3 = ["8","9_1","9_6","10_1","10_6","11_1","13_1"]
Standardeviation = ["ms_Vorticity_60mm/B00002.dat"]#,"ms_AvgV_60mm/B00002.dat"]
Files = []
ErrorFiles = []
for i in range(len(Str_2)):
    for Str in Str_3:
        Files.append(Str_1+Str+Str_2[i])
        ErrorFiles.append((Str_1+Str+Standardeviation[i]))

"plotting"
fig,ax = plt.subplots(1,len(Str_2),figsize=(6.2,5.2))

"For the legend"
Ref_Velo_1 = [8,9.1,9.6,10.1,10.6,11.1,13.1]
k=0
Ref_Velo = [8,9.1,9.6,10.1,10.6,11.1,13.1]
for i in range(len(Ref_Velo)):
    Ref_Velo[i] = "$U_{ref}$ = "+str(Ref_Velo[i])+"m/s"


D=4.8
for i in range(len(Str_2)):
    for j in range(len(Str_3)):
        xy = SF.xy_plotting(Files[j+k])
        y = [Value/D for Value in xy[0]]
        x = [Value*D/(1000*Ref_Velo_1[j]) for Value in xy[1]]

        "Calculating the error and add for errorbars"
        Vorticity_error = [Value for Value in SF.xy_plotting(ErrorFiles[j + k])[1]]

        PosinfVort = y[(x.index(min(x))+x.index(max(x)))/2]
        yplot = []
        xplot = []
        Vorticity_errorplot = []
        for y_val in y:
            Range  = 5
            if y_val >= PosinfVort-Range and PosinfVort+Range >= y_val:
                yplot.append(y_val)
                xplot.append(x[y.index(y_val)])
                Vorticity_errorplot.append(Vorticity_error[y.index(y_val)])

        "Choose which data has errorbars"
        if len(Str_2)<2:
            if Str_3[j+k] == "9_1_" or Str_3[j+k]=='13_1_' :
                plt.errorbar(xplot,yplot,xerr=Vorticity_errorplot,
                             capsize=2,label = Ref_Velo[j],marker='o',markerfacecolor ='None')
            else:
                plt.plot(xplot,yplot,label = Ref_Velo[j])
            plt.xlim(-0.3, 0.3)
            plt.ylim(13,17.5)
            plt.grid()
            "For several plots within the same figure"
        else:
            if Str_3[j+k] == "9_1_" or Str_3[j+k]=='13_1_' :
                ax[i].errorbar(xplot,yplot,xerr=Vorticity_errorplot,
                               capsize=2,label = Ref_Velo[j],marker='o',markerfacecolor ='None')
            else:
                ax[i].plot(xplot,yplot,label = Ref_Velo[j])
            ax[i].grid()
            plt.xlim(-0.3, 0.3)
            ax[i].set_ylim(13,17.5)
            ax[i].set_title(Str_2[i].split('ms_Vorticity_')[1].split('/')[0])

    k = k + len(Str_3)

"To organise the legend such that it is alphabethical"
handles, labels = ax.get_legend_handles_labels()
handles_sort = []
for i in range(len(labels)):
    handles_sort.append(handles[labels.index(Ref_Velo[i])])

plt.legend(handles_sort,Ref_Velo,fontsize = 12,loc='upper left')

"To add common y and x labels"
fig.add_subplot(111, frameon=False)
plt.tick_params(labelcolor='none', top=False, bottom=False, left=False, right=False)
plt.ylabel("y/D",fontsize = 14)
plt.xlabel(r'$\dfrac{-Vorticity \cdot D}{U_{ref}}$',fontsize = 14)

fig.tight_layout()
plt.savefig("PICS/GraphsToUse/VorticitySYM_60mm.pdf")
plt.show()